=== modified file 'Makefile'
--- Makefile	2008-07-22 01:59:47 +0000
+++ Makefile	2008-07-21 15:34:44 +0000
@@ -1,12 +1,11 @@
 WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs -Wswitch-default -Wswitch-enum -Wunused-parameter -Wstrict-aliasing=2 -Wextra -Wfloat-equal -Wundef -Wshadow -Wunsafe-loop-optimizations -Wpointer-arith -Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wstrict-prototypes -Wold-style-definition -Wpacked -Wnested-externs -Wunreachable-code -Winline -Wvolatile-register-var 
 DEBUG=-ggdb3
 #COVERAGE=--coverage
-OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 
 # Do not change these two
-CFLAGS=$(WARN) $(COVERAGE) $(DEBUG) $(OPTIMIZE) $(LANGUAGE)
 LDFLAGS=$(COVERAGE)
+CFLAGS=$(WARN) $(COVERAGE) $(DEBUG) $(LANGUAGE)
 
 PROGS=plugbasedclient plugins.d/mandosclient plugins.d/passprompt
 

=== modified file 'TODO'
--- TODO	2008-07-22 06:23:29 +0000
+++ TODO	2008-07-21 01:50:31 +0000
@@ -1,25 +1,19 @@
 [Mandos client]
-configuration for OpenPGP key
-header files/symbols tally
-check exit codes of all system calls
+configuration for OpenPGP key and interface
 IPv4 support
 
 [Pluginbasedclient]
 disable certain plugins
-header files/symbols tally
-check exit codes of all system calls
 change uid to nobody:nogroup
 	other drop privs stuff?
 
 [Server]
 config file for:
 	TXT record
+	GnuTLS priority string
 run-time communication with server
 
 [Mandos-tools/utilities]
 	List clients
 	Enable client
 	Disable client
-
-[Installer]
-...

=== modified file 'mandos-clients.conf'
--- mandos-clients.conf	2008-07-22 06:23:29 +0000
+++ mandos-clients.conf	2008-07-20 06:33:48 +0000
@@ -1,8 +1,3 @@
-[DEFAULT]
-timeout = 1h
-interval = 5m
-checker = fping -q -- %%(fqdn)s
-
 # Example
 [foo]
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-07-22 05:26:44 +0000
+++ plugbasedclient.c	2008-07-21 15:34:44 +0000
@@ -39,7 +39,6 @@
 #include <stdbool.h>	/* true */
 #include <sys/wait.h>	/* waitpid, WIFEXITED, WEXITSTATUS */
 #include <errno.h>	/* errno */
-#include <argp.h>	/* argp */
 
 struct process;
 
@@ -52,63 +51,8 @@
   struct process *next;
 } process;
 
-typedef struct plugin{
-  char *name; 		/* can be "global" and any plugin name */
-  char **argv;
-  int argc;
-  struct plugin *next;
-} plugin;
-
-plugin *getplugin(char *name, plugin **plugin_list){
-  for (plugin *p = *plugin_list; p != NULL; p = p->next){
-    if ((p->name == name)
-	or (p->name and name and (strcmp(p->name, name) == 0))){
-      return p;
-    }
-  }
-  /* Create a new plugin */
-  plugin *new_plugin = malloc(sizeof(plugin));
-  if (new_plugin == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->name = name;
-  new_plugin->argv = malloc(sizeof(char *) * 2);
-  if (new_plugin->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->argv[0] = name;
-  new_plugin->argv[1] = NULL;
-  new_plugin->argc = 1;
-  /* Append the new plugin to the list */
-  new_plugin->next = *plugin_list;
-  *plugin_list = new_plugin;
-  return new_plugin;
-}
-
-void addarguments(plugin *p, char *arg){
-  p->argv[p->argc] = arg;
-  p->argv = realloc(p->argv, sizeof(char *) * (size_t)(p->argc + 2));
-  if (p->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  p->argc++;
-  p->argv[p->argc] = NULL;
-}
-	
 #define BUFFER_SIZE 256
 
-const char *argp_program_version =
-  "plugbasedclient 0.9";
-const char *argp_program_bug_address =
-  "<mandos@fukt.bsnet.se>";
-static char doc[] =
-  "Mandos plugin runner -- Run Mandos plugins";
-/* A description of the arguments we accept. */
-static char args_doc[] = "";
-
 int main(int argc, char *argv[]){
   char plugindir[] = "plugins.d";
   size_t d_name_len, plugindir_len = sizeof(plugindir)-1;
@@ -119,71 +63,8 @@
   int ret, maxfd = 0;
   process *process_list = NULL;
   
-  /* The options we understand. */
-  struct argp_option options[] = {
-    { .name = "global-options", .key = 'g',
-      .arg = "option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting all plugins" },
-    { .name = "options-for", .key = 'o',
-      .arg = "plugin:option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting only specified plugins" },
-    { .name = NULL }
-  };
-  
-  error_t parse_opt (int key, char *arg, struct argp_state *state) {
-       /* Get the INPUT argument from `argp_parse', which we
-          know is a pointer to our arguments structure. */
-    plugin **plugins = state->input;
-    switch (key) {
-    case 'g':
-      if (arg != NULL){
-	char *p = strtok(arg, ",");
-	do{
-	  addarguments(getplugin(NULL, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case 'o':
-      if (arg != NULL){
-	char *name = strtok(arg, ":");
-	char *p = strtok(NULL, ":");
-	p = strtok(p, ",");
-	do{
-	  addarguments(getplugin(name, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case ARGP_KEY_ARG:
-      argp_usage (state);
-      break;
-    case ARGP_KEY_END:
-      break;
-    default:
-      return ARGP_ERR_UNKNOWN;
-    }
-    return 0;
-  }
-
-  plugin *plugin_list = NULL;
-  
-  struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = args_doc, .doc = doc };
-
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
-
-/*   for(plugin *p = plugin_list; p != NULL; p=p->next){ */
-/*     fprintf(stderr, "Plugin: %s has %d arguments\n", p->name ? p->name : "Global", p->argc); */
-/*     for(char **a = p->argv + 1; *a != NULL; a++){ */
-/*       fprintf(stderr, "\tArg: %s\n", *a); */
-/*     } */
-/*   } */
-  
-/*   return 0; */
-  
   dir = opendir(plugindir);
-  
+
   if(dir == NULL){
     fprintf(stderr, "Can not open directory\n");
     return EXIT_FAILURE;
@@ -218,31 +99,22 @@
       // Starting a new process to be watched
       process *new_process = malloc(sizeof(process));
       int pipefd[2];
-      ret = pipe(pipefd);
-      if (ret == -1){
-	perror(argv[0]);
-	goto end;
-      }
+      pipe(pipefd);
       new_process->pid = fork();
       if(new_process->pid == 0){
 	/* this is the child process */
 	closedir(dir);
 	close(pipefd[0]);	/* close unused read end of pipe */
 	dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
-	char *basename;
-	basename = strrchr(filename, '/');
-	if (basename == NULL){
-	  basename = filename;
-	} else {
-	  basename++;
-	}
-	plugin *p = getplugin(basename, &plugin_list);
-
-	plugin *g = getplugin(NULL, &plugin_list);
-	for(char **a = g->argv + 1; *a != NULL; a++){
-	  addarguments(p, *a);
-	}
-	if(execv(filename, p->argv) < 0){
+	/* create a new modified argument list */
+	char **new_argv = malloc(sizeof(char *)
+				 * ((unsigned int) argc + 1));
+	new_argv[0] = filename;
+	for(int i = 1; i < argc; i++){
+	  new_argv[i] = argv[i];
+	}
+	new_argv[argc] = NULL;
+	if(execv(filename, new_argv) < 0){
 	  perror(argv[0]);
 	  close(pipefd[1]);
 	  exit(EXIT_FAILURE);
@@ -307,17 +179,8 @@
 	      int status;
 	      waitpid(process_itr->pid, &status, 0);
 	      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
-		for(size_t written = 0;
-		    written < process_itr->buffer_length;){
-		  ret = write(STDOUT_FILENO,
-			      process_itr->buffer + written,
-			      process_itr->buffer_length - written);
-		  if(ret < 0){
-		    perror(argv[0]);
-		    goto end;
-		  }
-		  written += (size_t)ret;
-		}
+		write(STDOUT_FILENO, process_itr->buffer,
+		      process_itr->buffer_length);
 		goto end;
 	      } else {
 		FD_CLR(process_itr->fd, &rfds_orig);

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-07-22 06:23:29 +0000
+++ plugins.d/mandosclient.c	2008-07-21 15:34:44 +0000
@@ -48,8 +48,10 @@
 #include <avahi-common/error.h>
 
 //mandos client part
-#include <sys/types.h>		/* socket(), inet_pton() */
-#include <sys/socket.h>		/* socket(), struct sockaddr_in6,
+#include <sys/types.h>		/* socket(), setsockopt(),
+				   inet_pton() */
+#include <sys/socket.h>		/* socket(), setsockopt(),
+				   struct sockaddr_in6,
 				   struct in6_addr, inet_pton() */
 #include <gnutls/gnutls.h>	/* All GnuTLS stuff */
 #include <gnutls/openpgp.h>	/* GnuTLS with openpgp stuff */
@@ -193,7 +195,7 @@
   gpgme_data_release(dh_crypto);
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
-  gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET);
+  gpgme_data_seek(dh_plain, 0, SEEK_SET);
 
   *new_packet = 0;
   while(true){
@@ -343,7 +345,7 @@
 void empty_log(__attribute__((unused)) AvahiLogLevel level,
 	       __attribute__((unused)) const char *txt){}
 
-int start_mandos_communication(const char *ip, uint16_t port,
+int start_mandos_communication(char *ip, uint16_t port,
 			       unsigned int if_index){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
@@ -353,7 +355,6 @@
   size_t buffer_length = 0;
   size_t buffer_capacity = 0;
   ssize_t decrypted_buffer_size;
-  size_t written = 0;
   int retval = 0;
   char interface[IF_NAMESIZE];
   
@@ -378,7 +379,13 @@
     fprintf(stderr, "Binding to interface %s\n", interface);
   }
   
-  memset(&to,0,sizeof(to));	/* Spurious warning */
+  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, interface, 5);
+  if(ret < 0) {
+    perror("setsockopt bindtodevice");
+    return -1;
+  }
+  
+  memset(&to,0,sizeof(to));
   to.sin6_family = AF_INET6;
   ret = inet_pton(AF_INET6, ip, &to.sin6_addr);
   if (ret < 0 ){
@@ -389,7 +396,9 @@
     fprintf(stderr, "Bad address: %s\n", ip);
     return -1;
   }
-  to.sin6_port = htons(port);	/* Spurious warning */
+  /* Spurious warnings for the next line, see for instance
+     <http://bugs.debian.org/488884> */
+  to.sin6_port = htons(port);
   
   to.sin6_scope_id = (uint32_t)if_index;
   
@@ -419,10 +428,8 @@
   ret = gnutls_handshake (es.session);
   
   if (ret != GNUTLS_E_SUCCESS){
-    if(debug){
-      fprintf(stderr, "\n*** Handshake failed ***\n");
-      gnutls_perror (ret);
-    }
+    fprintf(stderr, "\n*** Handshake failed ***\n");
+    gnutls_perror (ret);
     retval = -1;
     goto exit;
   }
@@ -481,10 +488,9 @@
 					       &decrypted_buffer,
 					       CERT_ROOT);
     if (decrypted_buffer_size >= 0){
-      while(written < decrypted_buffer_size){
-	ret = (int)fwrite (decrypted_buffer + written, 1,
-			   (size_t)decrypted_buffer_size - written,
-			   stdout);
+      while(decrypted_buffer_size > 0){
+	ret = fwrite (decrypted_buffer, 1, (size_t)decrypted_buffer_size,
+		      stdout);
 	if(ret == 0 and ferror(stdout)){
 	  if(debug){
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
@@ -493,7 +499,8 @@
 	  retval = -1;
 	  break;
 	}
-	written += (size_t)ret;
+	decrypted_buffer += ret;
+	decrypted_buffer_size -= ret;
       }
       free(decrypted_buffer);
     } else {
@@ -522,7 +529,7 @@
 
 static void resolve_callback(
     AvahiSServiceResolver *r,
-    AvahiIfIndex interface,
+    AVAHI_GCC_UNUSED AvahiIfIndex interface,
     AVAHI_GCC_UNUSED AvahiProtocol protocol,
     AvahiResolverEvent event,
     const char *name,
@@ -535,11 +542,11 @@
     AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
     AVAHI_GCC_UNUSED void* userdata) {
     
-  assert(r);			/* Spurious warning */
-  
+  assert(r);
+
   /* Called whenever a service has been resolved successfully or
      timed out */
-  
+
   switch (event) {
   default:
   case AVAHI_RESOLVER_FAILURE:
@@ -547,19 +554,22 @@
 	    " type '%s' in domain '%s': %s\n", name, type, domain,
 	    avahi_strerror(avahi_server_errno(server)));
     break;
-    
+      
   case AVAHI_RESOLVER_FOUND:
     {
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf(stderr, "Mandos server \"%s\" found on %s (%s) on"
-		" port %d\n", name, host_name, ip, port);
+	fprintf(stderr, "Mandos server found on %s (%s) on port %d\n",
+		host_name, ip, port);
       }
       int ret = start_mandos_communication(ip, port,
-					   (unsigned int) interface);
+					   (unsigned int)
+					   interface);
       if (ret == 0){
 	exit(EXIT_SUCCESS);
+      } else {
+	exit(EXIT_FAILURE);
       }
     }
   }
@@ -578,11 +588,11 @@
     void* userdata) {
     
     AvahiServer *s = userdata;
-    assert(b);			/* Spurious warning */
-    
+    assert(b);
+
     /* Called whenever a new services becomes available on the LAN or
        is removed from the LAN */
-    
+
     switch (event) {
     default:
     case AVAHI_BROWSER_FAILURE:
@@ -628,11 +638,11 @@
 	{"debug", no_argument, (int *)&debug, 1},
 	{"interface", required_argument, 0, 'i'},
 	{0, 0, 0, 0} };
-      
+
       int option_index = 0;
       ret = getopt_long (argc, argv, "i:", long_options,
 			 &option_index);
-      
+
       if (ret == -1){
 	break;
       }

=== modified file 'server.py'
--- server.py	2008-07-22 06:23:29 +0000
+++ server.py	2008-07-21 01:50:31 +0000
@@ -87,7 +87,7 @@
 # Avahi example code.
 serviceInterface = avahi.IF_UNSPEC
 # From the Avahi example code:
-serviceName = None
+serviceName = "Mandos"
 serviceType = "_mandos._tcp" # http://www.dns-sd.org/ServiceTypes.html
 servicePort = None                      # Not known at startup
 serviceTXT = []                         # TXT record for the service
@@ -152,18 +152,16 @@
     interval = property(lambda self: self._interval,
                         _set_interval)
     del _set_interval
-    def __init__(self, name=None, stop_hook=None, fingerprint=None,
-                 secret=None, secfile=None, fqdn=None, timeout=None,
-                 interval=-1, checker=None):
+    def __init__(self, name=None, options=None, stop_hook=None,
+                 fingerprint=None, secret=None, secfile=None,
+                 fqdn=None, timeout=None, interval=-1, checker=None):
         """Note: the 'checker' argument sets the 'checker_command'
         attribute and not the 'checker' attribute.."""
         self.name = name
-        logger.debug(u"Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint
         # for later comparison purposes with return value of
         # the fingerprint() function
         self.fingerprint = fingerprint.upper().replace(u" ", u"")
-        logger.debug(u"  Fingerprint: %s", self.fingerprint)
         if secret:
             self.secret = secret.decode(u"base64")
         elif secfile:
@@ -176,8 +174,14 @@
         self.fqdn = fqdn                # string
         self.created = datetime.datetime.now()
         self.last_seen = None
-        self.timeout = string_to_delta(timeout)
-        self.interval = string_to_delta(interval)
+        if timeout is None:
+            self.timeout = options.timeout
+        else:
+            self.timeout = string_to_delta(timeout)
+        if interval == -1:
+            self.interval = options.interval
+        else:
+            self.interval = string_to_delta(interval)
         self.stop_hook = stop_hook
         self.checker = None
         self.checker_initiator_tag = None
@@ -373,9 +377,8 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        priority = "NORMAL"
-        if self.server.options.priority:
-            priority = self.server.options.priority
+        priority = "SECURE256"
+        
         gnutls.library.functions.gnutls_priority_set_direct\
             (session._c_object, priority, None);
         
@@ -633,16 +636,16 @@
                       help="Address to listen for requests on")
     parser.add_option("-p", "--port", type="int", default=None,
                       help="Port number to receive requests on")
+    parser.add_option("--timeout", type="string", # Parsed later
+                      default="1h",
+                      help="Amount of downtime allowed for clients")
+    parser.add_option("--interval", type="string", # Parsed later
+                      default="5m",
+                      help="How often to check that a client is up")
     parser.add_option("--check", action="store_true", default=False,
                       help="Run self-test")
     parser.add_option("--debug", action="store_true", default=False,
                       help="Debug mode")
-    parser.add_option("--priority", type="string",
-                      default="SECURE256",
-                      help="GnuTLS priority string"
-                      " (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      default="Mandos", help="Zeroconf service name")
     (options, args) = parser.parse_args()
     
     if options.check:
@@ -650,18 +653,22 @@
         doctest.testmod()
         sys.exit()
     
+    # Parse the time arguments
+    try:
+        options.timeout = string_to_delta(options.timeout)
+    except ValueError:
+        parser.error("option --timeout: Unparseable time")
+    try:
+        options.interval = string_to_delta(options.interval)
+    except ValueError:
+        parser.error("option --interval: Unparseable time")
+    
     # Parse config file
-    defaults = { "timeout": "1h",
-                 "interval": "5m",
-                 "checker": "fping -q -- %%(fqdn)s",
-                 }
+    defaults = { "checker": "fping -q -- %%(fqdn)s" }
     client_config = ConfigParser.SafeConfigParser(defaults)
     #client_config.readfp(open("global.conf"), "global.conf")
     client_config.read("mandos-clients.conf")
     
-    global serviceName
-    serviceName = options.servicename;
-    
     global main_loop
     global bus
     global server
@@ -691,7 +698,7 @@
             logger.debug(u"No clients left, exiting")
             killme()
     
-    clients.update(Set(Client(name=section,
+    clients.update(Set(Client(name=section, options=options,
                               stop_hook = remove_from_clients,
                               **(dict(client_config\
                                       .items(section))))

